##### $Id: OS_special.m4,v 1.7 1998/02/05 08:36:35 gskalla Exp $

dnl
dnl OS_NORMALIZE
dnl 		transforms a given email address from
dnl 			user@host.domain
dnl 			user<@host.domain.>
dnl 			...
dnl 		to
dnl 			user<@host.domain.>
dnl 		It is intended to be some sort of robust ...
dnl OS_NORMALIZE(gskalla@a.b.c.d)
dnl
dnl OS_SPECIAL
dnl 		builds a rule for the local part of rule set 0 (zero)
dnl 		depending on the number of arguments the rule is built
dnl 		for "local" or "smtp" mailer
dnl 		version 1.2:
dnl 		additional a forth argument is allowed to name the mailer
dnl
dnl OS_SPECIAL(xyz@crater.rz.uni-osnabrueck.de.,gskalla)
dnl OS_SPECIAL(abc@mailchk.uni-osnabrueck.de,gskalla,titan.rz.uni-osnabrueck.de)
dnl OS_SPECIAL(abc@mailchk.uni-osnabrueck.de,gskalla,to.be.ignored,PH)
dnl OS_SPECIAL(abc@any.where,message,error type,error) dnl dnl OS_ALT_DOMAIN
dnl 		alternative domain for users
dnl 		each user belongs automatically to domain 'rz.uni-osnabrueck.de'
dnl 		no check is done for that!
dnl 		Additional a user can belong to a domain corresponding
dnl 		to his login group (uopsy --> psycho etc.)
dnl 		(Mathematik/Informatik will have a problem!!)
dnl 		data base files for domains will be generated automatically
dnl 		from the NIS passwd map or another data base
dnl OS_ALT_DOMAIN(domain)
dnl
dnl OS_TRANSFORM',`R`'OS_NORMALIZE(`$1')	OS_NORMALIZE(`$2')')
dnl 		transform one expression to another
dnl		(I do not remember what this was meant to be for ...)
dnl OS_TRANSFORM(expr1,expr2)
dnl
dnl OS_PH_FORWARD
dnl		define rules for checking user part
dnl
dnl		check if address ends with host part $=D
dnl 		if so,	check if user part is local (user, aliases, mailuser)
dnl		otherwise forward to mailer PH
dnl		'OS_USE_PH_FORWARD' is redefined!!
dnl OS_PH_FORWARD
dnl OS_USE_PH_FORWARD
dnl 		forward addresses ending with host part $=D to mailer PH
dnl		affected by definitions in `OS_PH_FORWARD'!!
dnl		default: forward to mailer PH without any checking
dnl OS_USE_PH_FORWARD
dnl
dnl ------------------------------------------------------------------
dnl
define(OS_NORMALIZE, `regexp(`$1',`\([^<@]+\)<*\(@.*[^.>]\)[.>]*$',`\1<\2.> $'`*')')dnl	
dnl
dnl ------------------------------------------------------------------
dnl
define(`OS_SPECIAL',
	`ifelse(`$#',`2', R`'OS_NORMALIZE(`$1')	``$'`#''local $: `$2',
		`$#',`3',`R`'OS_NORMALIZE(`$1')	`$'`#'smtp `$'`@' `$3' `$'`:' `$2' <@`$3'>',
		`$#',`4',`ifelse(`$4',`PH',
				`R`'OS_NORMALIZE(`$1')	`$'`#'`$4' `$'`@' `$'`j' `$'`:' `$2'',
				 `$4',`error',
				`R`'OS_NORMALIZE(`$1')	`$'`#'`$4' `$'`@' `$3' `$'`:' `$2'',
				`R`'OS_NORMALIZE(`$1')	`$'`#'`$4' `$'`@' `$3' `$'`:' `$2' <@`$3'>' )' )' )dnl
dnl
dnl ------------------------------------------------------------------
dnl
define(`OS_ALT_DOMAIN',dnl
`ifelse(`$#',1,dnl
K$1 btree /etc/mail/user_in_domain/$1
R`$'+ < @ $1 . `$'=D . > `$'*dnl
	`$': `$'($1 `$'1 `$': `$'1.NOTFOUND `$') < @ $1 . `$'2 . > `$'3 R`$'+ . NOTFOUND < @ $1 . `$'D . > `$'*dnl
	`$'`#'error `$'@ USAGE `$': `$'1": no such user in domain <$1>",dnl `$#',2,dnl
K$1 btree /etc/mail/user_in_domain/$1
R`$'+ < @ $2 . > `$'*dnl
	`$': `$'($1 `$'1 `$': `$'1.NOTFOUND `$') < @ $2 . > `$'2 R`$'+ . NOTFOUND < @ $2 . > `$'*dnl
	`$'`#'error `$'@ USAGE `$': `$'1": no such user in domain <$2>")')dnl dnl dnl ------------------------------------------------------------------
dnl
define(`OS_TRANSFORM',`R`'OS_NORMALIZE(`$1')	OS_NORMALIZE(`$2')')
dnl
dnl ------------------------------------------------------------------
dnl
define(`OS_USE_PH_FORWARD',
R`$'+ < @ `$'=D . >		`$'#PH `$'@ `$'j `$': `$'1
)dnl
define(`OS_PH_FORWARD',
Kislocal user -m -a<>
Kislmu userdb -m -a<> maildrop
Kislal implicit -m -a<> ALIAS_FILE
dnl may be, some day I'll find out how to get that without code dupl. ...
define(`OS_USE_PH_FORWARD',
R``$''+ < @ ``$''=D . >		``$'': ``$''>check_local_user ``$''1 < @ ``$''2 >
)dnl  redefine `OS_USE_PH_FORWARD' for easier use

LOCAL_RULESETS
Scheck_local_user
R``$''+ < @ ``$''* >	``$'': ``$''( islocal ``$''1 ``$'') < @ ``$''2 >	look up user
R``$''+ <> < @ ``$''* >	``$''@ ``$''1 < @ ``$''2 . >			local
R``$''+ < @ ``$''* >	``$'': ``$''( islal ``$''1 ``$'') < @ ``$''2 >	look up aliases
R``$''+ <> < @ ``$''* >	``$''@ ``$''1 < @ ``$''2 . >			local
R``$''+ < @ ``$''* >	``$'': ``$''( islmu ``$''1 ``$'': ``$''1 ``$'') < @ ``$''2 >	look up mailuser
R``$''+ <> < @ ``$''* >	``$''@ ``$''1 < @ ``$''2 . >			local
R``$''+ < @ ``$''* >	``$''#PH ``$''@ ``$''2 ``$'': ``$''1	use mailer PH
)dnl
